<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Controllers\Controller;
use Illuminate\Pagination\Paginator;
use GuzzleHttp\Client;
use GuzzleHttp\Exception\ClientException;
use Illuminate\Support\Facades\Auth;
use Tymon\JWTAuth\Facades\JWTAuth;


use App\Models\User;
use Illuminate\Support\Facades\View;
use App\Models\Diamond;


class DiamondController extends Controller
{
    
    public function index(Request $request)
    {
      echo "Welcome to my app.";
      
        //   <a href="{{ url('/connect?shop=your-shop-name.myshopify.com') }}">Connect to Shopify</a>

      //   $request_uri = $_SERVER['REQUEST_URI']; 
      //   $url_parts = parse_url($request_uri);
        
      //   $shop_name = '';
      //   if (isset($url_parts['query'])) {
      //       parse_str($url_parts['query'], $query_params);
      //       // Output query parameters
      //       // echo "<pre>";
      //       // echo "Query Parameters:\n";
      //       // print_r($query_params);
      //       // print_r($query_params['shop']);
      //       // echo "</pre>";
      //       $shop_name = $query_params['shop'];
            
      //   }
      //   // $tbl_users_query = "select * from users where name = 'quickstart-fe166b91.myshopify.com'";
      //   $tbl_users_query = "select * from users where name = '$shop_name'";
      //   $user_data = DB::select($tbl_users_query); 
      //   // print_ex($user_data); die;
      // return view('theme', ['token'=>$user_data[0], 'shop_name' => $user_data[0]->name, 'theme_json' => $user_data[0]->theme_json, 'access_token' => $user_data[0]->access_token  ]);
    }
    
    public function load_more_data(Request $request){
     
      $stock_id = $request->stock_id; 
      $store_name = $request->store_name;
      $page_name = $request->page_name;
      $shop = $request->shop;
      //  print_r('hello'); die;

      // $token = hash('sha512',$request->shop);
     
      // $tbl_users_query = "select * from users where name = '$shop'  limit 1";
      
      // $user_data = DB::select($tbl_users_query);
      
      // // print_ex($user_data);
      // if(empty($user_data)){
      //   echo json_encode(array(
      //     'product_id'=> '',
      //     'variants_id'=> '',
      //     'records'=>'',
      //     'page_link'=>'',
      //     'total_records'=> '',
      //     'theme_json'=>'',
      //     'isLogin' => 0
      //   ));
      // }else{
        // $stock_id = $request->stock_id;
        // $page_name = $request->page_name;
        if(!empty($stock_id) && $page_name == 'diamond-details'){
          $diamond_query = "select * from tbl_diamond where stock_id = '$stock_id'  limit 1";
          $diamond_record = DB::select($diamond_query);
          echo json_encode(array(
            'records'=>$diamond_record,
            'page_name' => $page_name
          ));
        }else{
          
          // $theme_json = json_decode($user_data[0]->theme_json);

          $page=$request->page ?? 2;
          $per_page=$request->per_page ?? 50;
      
          $where = "cash_price > 0 ";
          $stock = $request->stock;       
          if(!empty($stock)) {                   
            $replacedStr = str_replace("," , "','", $stock);    
            $where .= " AND stock_id IN ('$replacedStr')"; 
          }  
      
          // $color = $request->color;                  
          // if(!empty($color)) {
          //   if(in_array('M', $color)) {
          //     array_push($color, "N", "O", "P", "Q", "R", "S");
          //   }
          //   $q = implode("','",$color);
          //   $where .= " AND color IN ('$q')";           
          // }

          $shape = $request->checkbox;
          // print_ex($shape);
          if (!empty($shape)) {
            $replacedStr = implode("','",$shape);             
            $where .= " AND shape IN ('$replacedStr')";      
          }

          $color = $request->color;                   
          if(!empty($color))
          {
              $color_array=array("D", "E", "F", "G", "H", "I", "J", "K", "L", "M");
              $color_array=$this->find_range($color,$color_array);
              $q2=implode("','",$color_array);
              $where .= " AND color IN ('".$q2."')";           
          }
          
          $checkboxcut = $request->cut;                
          if(!empty($checkboxcut))
          {         
              $array_va=array("EX", "VG", "G", "FR");
              $checkboxcut=$this->find_range($checkboxcut,$array_va);
              // if(in_array('Round',  $shape))
              // {
                $qcut = implode("','", $checkboxcut);
                $where .= " AND cut IN ('".$qcut."')";
              // }                  
          } 
          
          $checkboxClarity = $request->clarity;
          if(!empty($checkboxClarity))
          {        
            $clarity_va=array("FL","IF","VVS1","VVS2","VS1","VS2","SI1","SI2","SI3","I1","I2","I3");
            $checkboxClarity=$this->find_range($checkboxClarity,$clarity_va);
            $qClarity = implode("','", $checkboxClarity);
            $where .= " AND clarity IN ('".$qClarity."')";
          }  

          $price_from = $request->price_from;
          $price_to = $request->price_to;
          if (trim($price_from) != '' && trim($price_to)) {      
            $price_to = ($price_to=='0') ? '10000000' : $price_to;
            $where .= " AND cash_price BETWEEN ($price_from) AND ($price_to)";
          }

          // $price_from = $request->price_from;
          // $price_to = $request->price_to;
          // if (trim($price_from) != '' && trim($price_to)) {      
          //   $price_to = ($price_to=='0') ? '10000000' : $price_to;
          //   $where .= " AND cash_price BETWEEN ($price_from) AND ($price_to)";
          // }

          $carat_from = $request->carat_from;
          $carat_to = $request->carat_to;
          if (trim($carat_from) != '' && trim($carat_to)) {      
            $carat_to = ($carat_to=='0') ? '200' : $carat_to;
            $where .= " AND weight BETWEEN ($carat_from) AND ($carat_to)";
          }

          // $range = $request->carat_from;
          // $split = explode(';', $range);
          // $split1 = @$split['0'];    
          // $split2 = @$split['1'];
          // if($split2=='6'){
          //   $split2 = '20';
          // }     
          // if(!empty($range))
          // {        
          //   $where .= " AND weight BETWEEN ('".$split1."') AND ('".$split2."')";     
          // }



          // $polish = $request->polish;
          // if (!empty($polish)) {
          //   $replacedStr = implode("','",$polish);             
          //   $where .= " AND polish IN ('$replacedStr')";      
          // }

          // $symmetry = $request->symmetry;
          // if (!empty($symmetry)) {
          //   $replacedStr = implode("','",$symmetry);             
          //   $where .= " AND symmetry IN ('$replacedStr')";      
          // }

          
          // $fluorescence = $request->fluorescence;
          // if (!empty($fluorescence)) {
          //   $replacedStr = implode("','",$fluorescence);             
          //   $where .= " AND fluorescence_int IN ('$replacedStr')";      
          // }

          // $cert = $request->cert;
          // if (!empty($cert)) {
          //   $replacedStr = implode("','",$cert);             
          //   $where .= " AND lab IN ('$replacedStr')";      
          // }

          // $culet = $request->culet;
          // if (!empty($culet)) {
          //   $replacedStr = implode("','",$culet);             
          //   $where .= " AND culet IN ('$replacedStr')";      
          // }

          // $table_per_from = $request->table_per_from;
          // $table_per_to = $request->table_per_to;
          // if (trim($table_per_from) != '' && trim($table_per_to)) {      
          //   $table_per_to = ($table_per_to=='10') ? '200' : $table_per_to;
          //   $where .= " AND table_d BETWEEN ($table_per_from) AND ($table_per_to)";
          // }

          // $depth_per_from = $request->depth_per_from;
          // $depth_per_to = $request->depth_per_to;
          // if (trim($depth_per_from) != '' && trim($depth_per_to)) {      
          //   $depth_per_to = ($depth_per_to=='10') ? '200' : $depth_per_to;
          //   $where .= " AND depth BETWEEN ($depth_per_from) AND ($depth_per_to)";
          // }

          // $cr_angle_from = $request->cr_angle_from;
          // $cr_angle_to = $request->cr_angle_to;
          // if (trim($cr_angle_from) != '' && trim($cr_angle_to)) {      
          //   $cr_angle_to = ($cr_angle_to=='10') ? '200' : $cr_angle_to;
          //   $where .= " AND crown_angle BETWEEN ($cr_angle_from) AND ($cr_angle_to)";
          // }

          // $cr_height_from = $request->cr_height_from;
          // $cr_height_to = $request->cr_height_to;
          // if (trim($cr_height_from) != '' && trim($cr_height_to)) {      
          //   $cr_height_to = ($cr_height_to=='10') ? '200' : $cr_height_to;
          //   $where .= " AND crown_ht BETWEEN ($cr_height_from) AND ($cr_height_to)";
          // }

          // $pav_angle_from = $request->pav_angle_from;
          // $pav_angle_to = $request->pav_angle_to;
          // if (trim($pav_angle_from) != '' && trim($pav_angle_to)) {      
          //   $pav_angle_to = ($pav_angle_to=='10') ? '200' : $pav_angle_to;
          //   $where .= " AND pavillion_angle BETWEEN ($pav_angle_from) AND ($pav_angle_to)";
          // }

          // $pav_height_from = $request->pav_height_from;
          // $pav_height_to = $request->pav_height_to;
          // if (trim($pav_height_from) != '' && trim($pav_height_to)) {      
          //   $pav_height_to = ($pav_height_to=='10') ? '200' : $pav_height_to;
          //   $where .= " AND pavillion_depth BETWEEN ($pav_height_from) AND ($pav_height_to)";
          // }

          // $girdle_per_from = $request->girdle_per_from;
          // $girdle_per_to = $request->girdle_per_to;
          // if (trim($girdle_per_from) != '' && trim($girdle_per_to)) {      
          //   $girdle_per_to = ($girdle_per_to=='10') ? '200' : $girdle_per_to;
          //   $where .= " AND girdle_perct BETWEEN ($girdle_per_from) AND ($girdle_per_to)";
          // }

          // $star_len_from = $request->star_len_from;
          // $star_len_to = $request->star_len_to;
          // if (trim($star_len_from) != '' && trim($star_len_to)) {      
          //   $star_len_to = ($star_len_to=='10') ? '200' : $star_len_to;
          //   $where .= " AND star_len BETWEEN ($star_len_from) AND ($star_len_to)";
          // }

          $per_pages = $request->per_pages;
          $limit = ($per_pages != '') ? $per_pages : $per_page ;
          $offset = ($page - 1) * $limit;
          
          $query = "select * from tbl_diamond where " .$where." limit 0,$limit"; 
          $records = DB::select($query);
          // print_ex($records);
          
          $query1 = "select COUNT(diamond_id) AS diamond_count from tbl_diamond where " .$where;
          $records_count = DB::select($query1);
          $data['records_count'] =$records_count['0']->diamond_count;
          // print_ex($data);
          // echo json_encode(array(
          //   // 'pagination' => $pagination,
          //   'product_id'=>$product_id ?? '',
          //   'variants_id'=>$variants_id ?? '',
          //   'records'=>$records,
          //   'page_link'=>$pagination ?? '',
          //   'total_records'=>$data['records_count'],
          //   'theme_json'=>$theme_json ?? '',
          //   'isLogin' => 1,
          //   'page_name' => $page_name
          // ));

          $response_data = [
            'product_id' => $product_id ?? '',
            'variants_id' => $variants_id ?? '',
            'records' => $records,
            'page_link' => $pagination ?? '',
            'total_records' => $data['records_count'],
            'theme_json' => $theme_json ?? '',
            'isLogin' => 1,
            'page_name' => $page_name
        ];
    
        return response()->json($response_data)
                         ->header('Access-Control-Allow-Origin', '*')
                         ->header('Access-Control-Allow-Methods', 'GET, POST, PUT, DELETE, OPTIONS')
                         ->header('Access-Control-Allow-Headers', 'Content-Type, Authorization');


        }
      // }  
    }

    public function diamond_details(Request $request){
     
      $stock_id = $request->stock_id; 
      // $page_name = $request->page_name;

      $diamond_query = "select * from tbl_diamond where stock_id = '$stock_id'  limit 1";
      $diamond_record = DB::select($diamond_query);

      $response_data = [
        'records'=>$diamond_record,
        // 'page_name' => $page_name
      ];
    
      return response()->json($response_data)
                         ->header('Access-Control-Allow-Origin', '*')
                         ->header('Access-Control-Allow-Methods', 'GET, POST, PUT, DELETE, OPTIONS')
                         ->header('Access-Control-Allow-Headers', 'Content-Type, Authorization');
    }

    // public function load_more_data_old(Request $request){
     
    //   $stock_id = $request->stock_id; 
    //   $store_name = $request->store_name;
    //   $page_name = $request->page_name;
    //   $shop = $request->shop;
    //   // $token = $request->token;
    //   // print_ex($page_name);
    //   //  print_r('hello'); die;

    //   $token = hash('sha512',$request->shop);
     
    //   $tbl_users_query = "select * from users where name = '$shop'  limit 1";
      
    //   $user_data = DB::select($tbl_users_query);
      
    //   // print_ex($user_data);
    //   if(empty($user_data)){
    //     echo json_encode(array(
    //       'product_id'=> '',
    //       'variants_id'=> '',
    //       'records'=>'',
    //       'page_link'=>'',
    //       'total_records'=> '',
    //       'theme_json'=>'',
    //       'isLogin' => 0
    //     ));
    //   }else{
    //     // $stock_id = $request->stock_id;
    //     // $page_name = $request->page_name;
    //     if(!empty($stock_id) && $page_name == 'diamond-details'){
    //       $diamond_query = "select * from tbl_diamond where stock_id = '$stock_id'  limit 1";
    //       $diamond_record = DB::select($diamond_query);
    //       echo json_encode(array(
    //         'records'=>$diamond_record,
    //         'page_name' => $page_name
    //       ));
    //     }else{
    //       $theme_json = json_decode($user_data[0]->theme_json);
    //       // if($user_data[0]->access_token == ''){
    //       //   echo json_encode(array(
    //       //     'product_id'=> '',
    //       //     'variants_id'=> '',
    //       //     'records'=> [],
    //       //     'page_link'=> '',
    //       //     'total_records'=> '',
    //       //     'theme_json'=> '',
    //       //     'isLogin' => 0
    //       //   ));
    //       //   die;
    //       // }

    //       // if(!empty($stock_id) && !empty($store_name)) {

    //       //   $wheres = "dm.stock_id = '$stock_id' AND u.name = '$store_name'"; 
    //       //   $db_query = "SELECT u.name, dm.stock_id, dm.product_id, dm.variants_id  FROM users u JOIN tbl_diamond_manage dm ON u.id = dm.user_id WHERE ". $wheres;
    //       //   // print_ex($db_query);
    //       //   $record_tdm = DB::select($db_query);
    //       //   $tbl_diamond_query = "select * from tbl_diamond where stock_id = '$stock_id'";
    //       //   $tbl_diamond_data = DB::select($tbl_diamond_query); 
    //       //   if(!empty($record_tdm)){ 
    //       //     $product_id = $record_tdm[0]->product_id ?? '';
    //       //     $variants_id = $record_tdm[0]->variants_id ?? '';
    //       //   }else{
              
    //       //     $description = '<p>';
    //       //       $description .= ($tbl_diamond_data[0]->stock_id != '') ? 'Stock No : '.$tbl_diamond_data[0]->stock_id : '';
    //       //       $description .= ($tbl_diamond_data[0]->availability != '') ? '<br>Availability : '.$tbl_diamond_data[0]->availability : '';
    //       //       $description .= ($tbl_diamond_data[0]->shape != '') ? '<br>Shape : '.$tbl_diamond_data[0]->shape : '';
    //       //       $description .= ($tbl_diamond_data[0]->weight != '') ? '<br>Weight : '.$tbl_diamond_data[0]->weight : '';
    //       //       $description .= ($tbl_diamond_data[0]->color != '') ? '<br>Color : '.$tbl_diamond_data[0]->color : '';
    //       //       $description .= ($tbl_diamond_data[0]->grade != '') ? '<br>Grade : '.$tbl_diamond_data[0]->grade : '';
    //       //       $description .= ($tbl_diamond_data[0]->cut != '') ? '<br>cut : '.$tbl_diamond_data[0]->cut : '';
    //       //       $description .= ($tbl_diamond_data[0]->polish != '') ? '<br>Polish : '.$tbl_diamond_data[0]->polish : '';
    //       //       $description .= ($tbl_diamond_data[0]->symmetry != '') ? '<br>Symmetry : '.$tbl_diamond_data[0]->symmetry : '';
    //       //       $description .= ($tbl_diamond_data[0]->fluorescence_int != '') ? '<br>Fluorescence Intensity : '.$tbl_diamond_data[0]->fluorescence_int : '';
    //       //       $description .= ($tbl_diamond_data[0]->fluorescence_color != '') ? '<br>Fluorescence Color : '.$tbl_diamond_data[0]->fluorescence_color : '';
    //       //       $description .= ($tbl_diamond_data[0]->measurements != '') ? '<br>Measurements : '.$tbl_diamond_data[0]->measurements : '';
    //       //       $description .= ($tbl_diamond_data[0]->lab != '') ? '<br>Lab : '.$tbl_diamond_data[0]->lab : '';
    //       //       $description .= ($tbl_diamond_data[0]->depth != '') ? '<br>Depth Per : '.$tbl_diamond_data[0]->depth : '';
    //       //       $description .= ($tbl_diamond_data[0]->table_d != '') ? '<br>Table Per : '.$tbl_diamond_data[0]->table_d : '';
    //       //       $description .= ($tbl_diamond_data[0]->girdle_thin != '') ? '<br>Girdle Min : '.$tbl_diamond_data[0]->girdle_thin : '';
    //       //       $description .= ($tbl_diamond_data[0]->girdle_thick != '') ? '<br>Girdle Max : '.$tbl_diamond_data[0]->girdle_thick : '';
    //       //       $description .= ($tbl_diamond_data[0]->girdle_perct != '') ? '<br>Girdle Per : '.$tbl_diamond_data[0]->girdle_perct : '';
    //       //       $description .= ($tbl_diamond_data[0]->girdle_con != '') ? '<br>Girdle Condition : '.$tbl_diamond_data[0]->girdle_con : '';
    //       //       $description .= ($tbl_diamond_data[0]->culet_size != '') ? '<br>Culet Size : '.$tbl_diamond_data[0]->culet_size : '';
    //       //       $description .= ($tbl_diamond_data[0]->culet_con != '') ? '<br>Culet Condition : '.$tbl_diamond_data[0]->culet_con : '';
    //       //       $description .= ($tbl_diamond_data[0]->crown_ht != '') ? '<br>Crown Height : '.$tbl_diamond_data[0]->crown_ht : '';
    //       //       $description .= ($tbl_diamond_data[0]->crown_angle != '') ? '<br>Crown Angle : '.$tbl_diamond_data[0]->crown_angle : '';
    //       //       $description .= ($tbl_diamond_data[0]->pavillion_depth != '') ? '<br>Pavilion Depth : '.$tbl_diamond_data[0]->pavillion_depth : '';
    //       //       $description .= ($tbl_diamond_data[0]->pavillion_angle != '') ? '<br>Pavilion Angle : '.$tbl_diamond_data[0]->pavillion_angle : '';
    //       //       $description .= ($tbl_diamond_data[0]->country != '') ? '<br>Country : '.$tbl_diamond_data[0]->country : '';
    //       //       $description .= ($tbl_diamond_data[0]->state != '') ? '<br>State : '.$tbl_diamond_data[0]->state : '';
    //       //       $description .= ($tbl_diamond_data[0]->city != '') ? '<br>City : '.$tbl_diamond_data[0]->city : '';
    //       //       $description .= ($tbl_diamond_data[0]->diamond_type != '') ? '<br>Diamond Type : '.$tbl_diamond_data[0]->diamond_type : '';
    //       //       $description .= ($tbl_diamond_data[0]->keytosymb != '') ? '<br>Key_To_Symbols : '.$tbl_diamond_data[0]->keytosymb : '';
    //       //       $description .= ($tbl_diamond_data[0]->member_comment != '') ? '<br>Member Comment : '.$tbl_diamond_data[0]->member_comment : '';
    //       //       $description .= ($tbl_diamond_data[0]->brand != '') ? '<br>Brand : '.$tbl_diamond_data[0]->brand : '';
    //       //       // $description .= (hasValue($tbl_diamond_data[0]->Ratio)) ? '<br>Ratio : '.$tbl_diamond_data[0]->Ratio : '';
    //       //     $description .= '</p>';
    //       //     // print_pre($description);
    //       //     // print_ex($tbl_diamond_data);
    //       //     if(!empty($tbl_diamond_data[0]->diamond_image)){
    //       //       $img = checkLink($tbl_diamond_data[0]->diamond_image);
    //       //       if($img == 200){
    //       //         $diamond_img = $tbl_diamond_data[0]->diamond_image;
    //       //         $alt = $tbl_diamond_data[0]->shape;
    //       //       }else{
    //       //         $diamond_img = public_path('assets/No_image.jpg');
    //       //         $alt = "No image";	
    //       //       }
    //       //     }else{
    //       //       $diamond_img = public_path('assets/No_image.jpg');
    //       //       $alt = "No image";	
    //       //     }

              
    //       //     $variants = [
    //       //       'sku' => $tbl_diamond_data[0]->stock_id,
    //       //       // 'barcode' => $tbl_diamond_data[0]->barcode,
    //       //       'price' => $tbl_diamond_data[0]->cash_price,
    //       //       // 'compare_at_price' => $tbl_diamond_data[0]->Buy_Price,
    //       //       'cost' => $tbl_diamond_data[0]->cash_price,                    
    //       //       'inventory_quantity' => 10,
    //       //       // 'grams' => $row->grams,
    //       //       'taxable' => true,
    //       //       'requires_shipping' => true,
    //       //       'fulfillment_service' => 'manual',
    //       //       'inventory_policy' => 'deny',
    //       //       'inventory_management' => 'shopify'
    //       //     ];

    //       //     $dataSend = [
    //       //       'product' => [
    //       //         'title' => $tbl_diamond_data[0]->stock_id ." ". $tbl_diamond_data[0]->shape ." Diamond ". $tbl_diamond_data[0]->weight ." ". $tbl_diamond_data[0]->color ." ". $tbl_diamond_data[0]->grade ,
    //       //         'body_html' => $description,
    //       //         'product_type' => $tbl_diamond_data[0]->diamond_type,
    //       //         'handle' => $tbl_diamond_data[0]->stock_id,
    //       //         'status' => 'active',
    //       //         'vendor' => $store_name,
    //       //         'variants' => [
    //       //           $variants
    //       //         ],
    //       //         'images' => [
    //       //           [
    //       //             "position"=> 1,
    //       //             "alt"=> $alt,
    //       //             "src"=> $diamond_img 
    //       //           ]
    //       //         ],
    //       //         'metafields' => [
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "stock_id",
    //       //             'value' => $tbl_diamond_data[0]->stock_id,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "availability",
    //       //             'value' => $tbl_diamond_data[0]->availability,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "shape",
    //       //             'value' => $tbl_diamond_data[0]->shape,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "weight",
    //       //             'value' => $tbl_diamond_data[0]->weight,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "color",
    //       //             'value' => $tbl_diamond_data[0]->color,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           // [
    //       //           //   'namespace' => "Diamond",
    //       //           //   'key' => "clarity",
    //       //           //   'value' => $tbl_diamond_data[0]->clarity,
    //       //           //   'type' => "single_line_text_field",
    //       //           // ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "cut",
    //       //             'value' => $tbl_diamond_data[0]->cut,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "polish",
    //       //             'value' => $tbl_diamond_data[0]->polish,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "symmetry",
    //       //             'value' => $tbl_diamond_data[0]->symmetry,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "fluor",
    //       //             'value' => $tbl_diamond_data[0]->fluorescence_int,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "Fluorescence_Color",
    //       //             'value' => $tbl_diamond_data[0]->fluorescence_color,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "measurements",
    //       //             'value' => $tbl_diamond_data[0]->measurements,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "lab",
    //       //             'value' => $tbl_diamond_data[0]->lab,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "depth",
    //       //             'value' => $tbl_diamond_data[0]->depth,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "table_d",
    //       //             'value' => $tbl_diamond_data[0]->table_d,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           // [
    //       //           // 	'namespace' => "Diamond",
    //       //           // 	'key' => "girdle_min",
    //       //           // 	'value' => $tbl_diamond_data[0]->Girdle_Min,
    //       //           // 	'type' => "single_line_text_field",
    //       //           // ],
    //       //           // [
    //       //           // 	'namespace' => "Diamond",
    //       //           // 	'key' => "girdle_max",
    //       //           // 	'value' => $tbl_diamond_data[0]->Girdle_Max,
    //       //           // 	'type' => "single_line_text_field",
    //       //           // ],
    //       //           // [
    //       //           // 	'namespace' => "Diamond",
    //       //           // 	'key' => "girdle_per",
    //       //           // 	'value' => $tbl_diamond_data[0]->Girdle_Per,
    //       //           // 	'type' => "single_line_text_field",
    //       //           // ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "culet_size",
    //       //             'value' => $tbl_diamond_data[0]->culet_size,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "crown_angle",
    //       //             'value' => $tbl_diamond_data[0]->crown_angle,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "crown_ht",
    //       //             'value' => $tbl_diamond_data[0]->crown_ht,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "pavillion_angle",
    //       //             'value' => $tbl_diamond_data[0]->pavillion_angle,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "pavillion_depth",
    //       //             'value' => $tbl_diamond_data[0]->pavillion_depth,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           // [
    //       //           //   'namespace' => "Diamond",
    //       //           //   'key' => "star_len",
    //       //           //   'value' => $tbl_diamond_data[0]->star_len,
    //       //           //   'type' => "single_line_text_field",
    //       //           // ],
    //       //           // [
    //       //           // 	'namespace' => "Diamond",
    //       //           // 	'key' => "cert_comments",
    //       //           // 	'value' => $tbl_diamond_data[0]->comments,
    //       //           // 	'type' => "single_line_text_field",
    //       //           // ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "Member_Comments",
    //       //             'value' => $tbl_diamond_data[0]->member_comment,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "country",
    //       //             'value' => $tbl_diamond_data[0]->country,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "state",
    //       //             'value' => $tbl_diamond_data[0]->state,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "city",
    //       //             'value' => $tbl_diamond_data[0]->city,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           // [
    //       //           // 	'namespace' => "Diamond",
    //       //           // 	'key' => "Country_Of_Origin",
    //       //           // 	'value' => $tbl_diamond_data[0]->Country_Of_Origin,
    //       //           // 	'type' => "single_line_text_field",
    //       //           // ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "price",
    //       //             'value' => $tbl_diamond_data[0]->cash_price,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           // [
    //       //           //   'namespace' => "Diamond",
    //       //           //   'key' => "ratio",
    //       //           //   'value' => $tbl_diamond_data[0]->ratio,
    //       //           //   'type' => "single_line_text_field",
    //       //           // ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "ImageLink",
    //       //             'value' => $tbl_diamond_data[0]->diamond_image,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "VideoLink",
    //       //             'value' => $tbl_diamond_data[0]->diamond_video,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           // [
    //       //           //   'namespace' => "Diamond",
    //       //           //   'key' => "Video_HTML",
    //       //           //   'value' => $tbl_diamond_data[0]->Video_HTML,
    //       //           //   'type' => "single_line_text_field",
    //       //           // ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "CertificateLink",
    //       //             'value' => $tbl_diamond_data[0]->report_filename,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           [
    //       //             'namespace' => "Diamond",
    //       //             'key' => "Rap_Price",
    //       //             'value' => $tbl_diamond_data[0]->rapnet,
    //       //             'type' => "single_line_text_field",
    //       //           ],
    //       //           // [
    //       //           // 	'namespace' => "Diamond",
    //       //           // 	'key' => "Memo_Price",
    //       //           // 	'value' => $tbl_diamond_data[0]->Memo_Price,
    //       //           // 	'type' => "single_line_text_field",
    //       //           // ],
    //       //           // [
    //       //           // 	'namespace' => "Diamond",
    //       //           // 	'key' => "Memo_Discount_PER",
    //       //           // 	'value' => $tbl_diamond_data[0]->Memo_Discount_PER,
    //       //           // 	'type' => "single_line_text_field",
    //       //           // ],
    //       //           // [
    //       //           // 	'namespace' => "Diamond",
    //       //           // 	'key' => "Buy_Price",
    //       //           // 	'value' => $tbl_diamond_data[0]->Buy_Price,
    //       //           // 	'type' => "single_line_text_field",
    //       //           // ],
    //       //           // [
    //       //           // 	'namespace' => "Diamond",
    //       //           // 	'key' => "Buy_Price_Discount_PER",
    //       //           // 	'value' => $tbl_diamond_data[0]->Buy_Price_Discount_PER,
    //       //           // 	'type' => "single_line_text_field",
    //       //           // ],
    //       //           // [
    //       //           // 	'namespace' => "Diamond",
    //       //           // 	'key' => "COD_Buy_Price",
    //       //           // 	'value' => $tbl_diamond_data[0]->COD_Buy_Price,
    //       //           // 	'type' => "single_line_text_field",
    //       //           // ],
    //       //           // [
    //       //           // 	'namespace' => "Diamond",
    //       //           // 	'key' => "COD_Buy_Price_Discount_PER",
    //       //           // 	'value' => $tbl_diamond_data[0]->COD_Buy_Price_Discount_PER,
    //       //           // 	'type' => "single_line_text_field",
    //       //           // ],
    //       //           // [
    //       //           // 	'namespace' => "Diamond",
    //       //           // 	'key' => "Certificate",
    //       //           // 	'value' => $tbl_diamond_data[0]->Certificate,
    //       //           // 	'type' => "single_line_text_field",
    //       //           // ]
    //       //         ],
    //       //       ]
    //       //     ];
    //       //     $accessToken = $user_data[0]->access_token ?? '';
    //       //     $shop = $user_data[0]->name ?? '';
    //       //     // print_ex($shop);
    //       //     $newRecord = $this->createProduct(json_encode($dataSend),$shop,$accessToken);
    //       //     $product_id = $newRecord->product->id ?? '';
    //       //     $variants_id = $newRecord->product->variants[0]->id ?? '';
    //       //     $user_id = 1; 
    //       //     $shopify_upload = 1;
    //       //     $shopify_update = 0;
    //       //     $shopify_response = json_encode($newRecord);
    //       //     $created_at = date('Y-m-d H:i:s');

    //       //     try {
    //       //       DB::insert("
    //       //           INSERT INTO tbl_diamond_manage (
    //       //               stock_id,
    //       //               product_id,
    //       //               variants_id,
    //       //               user_id,
    //       //               store_name,
    //       //               shopify_upload,
    //       //               shopify_update,
    //       //               shopify_response,
    //       //               created_at
    //       //           ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)",
    //       //           [$stock_id, $product_id, $variants_id, $user_id, $store_name, $shopify_upload, $shopify_update, $shopify_response, $created_at]
    //       //       );
        
    //       //       // echo "Data inserted successfully!";
    //       //     } catch (QueryException $e) { 
    //       //         echo "Error inserting data: " . $e->getMessage();
    //       //     }

    //       //   }
    //       // }  

    //       $page=$request->page ?? 2;
    //       $per_page=$request->per_page ?? 50;
      
    //       $where = "cash_price > 0 ";
    //       $stock = $request->stock;       
    //       if(!empty($stock)) {                   
    //         $replacedStr = str_replace("," , "','", $stock);    
    //         $where .= " AND stock_id IN ('$replacedStr')"; 
    //       }  
      
    //       // $color = $request->color;                  
    //       // if(!empty($color)) {
    //       //   if(in_array('M', $color)) {
    //       //     array_push($color, "N", "O", "P", "Q", "R", "S");
    //       //   }
    //       //   $q = implode("','",$color);
    //       //   $where .= " AND color IN ('$q')";           
    //       // }

    //       $shape = $request->checkbox;
    //       // print_ex($shape);
    //       if (!empty($shape)) {
    //         $replacedStr = implode("','",$shape);             
    //         $where .= " AND shape IN ('$replacedStr')";      
    //       }

    //       $color = $request->color;                   
    //       if(!empty($color))
    //       {
    //           $color_array=array("D", "E", "F", "G", "H", "I", "J", "K", "L", "M");
    //           $color_array=$this->find_range($color,$color_array);
    //           $q2=implode("','",$color_array);
    //           $where .= " AND color IN ('".$q2."')";           
    //       }
          
    //       $checkboxcut = $request->cut;                
    //       if(!empty($checkboxcut))
    //       {         
    //           $array_va=array("EX", "VG", "G", "FR");
    //           $checkboxcut=$this->find_range($checkboxcut,$array_va);
    //           // if(in_array('Round',  $shape))
    //           // {
    //             $qcut = implode("','", $checkboxcut);
    //             $where .= " AND cut IN ('".$qcut."')";
    //           // }                  
    //       } 
          
    //       $checkboxClarity = $request->clarity;
    //       if(!empty($checkboxClarity))
    //       {        
    //         $clarity_va=array("FL","IF","VVS1","VVS2","VS1","VS2","SI1","SI2","SI3","I1","I2","I3");
    //         $checkboxClarity=$this->find_range($checkboxClarity,$clarity_va);
    //         $qClarity = implode("','", $checkboxClarity);
    //         $where .= " AND clarity IN ('".$qClarity."')";
    //       }  

    //       $price_from = $request->price_from;
    //       $price_to = $request->price_to;
    //       if (trim($price_from) != '' && trim($price_to)) {      
    //         $price_to = ($price_to=='0') ? '10000000' : $price_to;
    //         $where .= " AND cash_price BETWEEN ($price_from) AND ($price_to)";
    //       }

    //       // $price_from = $request->price_from;
    //       // $price_to = $request->price_to;
    //       // if (trim($price_from) != '' && trim($price_to)) {      
    //       //   $price_to = ($price_to=='0') ? '10000000' : $price_to;
    //       //   $where .= " AND cash_price BETWEEN ($price_from) AND ($price_to)";
    //       // }

    //       $carat_from = $request->carat_from;
    //       $carat_to = $request->carat_to;
    //       if (trim($carat_from) != '' && trim($carat_to)) {      
    //         $carat_to = ($carat_to=='0') ? '200' : $carat_to;
    //         $where .= " AND weight BETWEEN ($carat_from) AND ($carat_to)";
    //       }

    //       // $range = $request->carat_from;
    //       // $split = explode(';', $range);
    //       // $split1 = @$split['0'];    
    //       // $split2 = @$split['1'];
    //       // if($split2=='6'){
    //       //   $split2 = '20';
    //       // }     
    //       // if(!empty($range))
    //       // {        
    //       //   $where .= " AND weight BETWEEN ('".$split1."') AND ('".$split2."')";     
    //       // }



    //       // $polish = $request->polish;
    //       // if (!empty($polish)) {
    //       //   $replacedStr = implode("','",$polish);             
    //       //   $where .= " AND polish IN ('$replacedStr')";      
    //       // }

    //       // $symmetry = $request->symmetry;
    //       // if (!empty($symmetry)) {
    //       //   $replacedStr = implode("','",$symmetry);             
    //       //   $where .= " AND symmetry IN ('$replacedStr')";      
    //       // }

          
    //       // $fluorescence = $request->fluorescence;
    //       // if (!empty($fluorescence)) {
    //       //   $replacedStr = implode("','",$fluorescence);             
    //       //   $where .= " AND fluorescence_int IN ('$replacedStr')";      
    //       // }

    //       // $cert = $request->cert;
    //       // if (!empty($cert)) {
    //       //   $replacedStr = implode("','",$cert);             
    //       //   $where .= " AND lab IN ('$replacedStr')";      
    //       // }

    //       // $culet = $request->culet;
    //       // if (!empty($culet)) {
    //       //   $replacedStr = implode("','",$culet);             
    //       //   $where .= " AND culet IN ('$replacedStr')";      
    //       // }

    //       // $table_per_from = $request->table_per_from;
    //       // $table_per_to = $request->table_per_to;
    //       // if (trim($table_per_from) != '' && trim($table_per_to)) {      
    //       //   $table_per_to = ($table_per_to=='10') ? '200' : $table_per_to;
    //       //   $where .= " AND table_d BETWEEN ($table_per_from) AND ($table_per_to)";
    //       // }

    //       // $depth_per_from = $request->depth_per_from;
    //       // $depth_per_to = $request->depth_per_to;
    //       // if (trim($depth_per_from) != '' && trim($depth_per_to)) {      
    //       //   $depth_per_to = ($depth_per_to=='10') ? '200' : $depth_per_to;
    //       //   $where .= " AND depth BETWEEN ($depth_per_from) AND ($depth_per_to)";
    //       // }

    //       // $cr_angle_from = $request->cr_angle_from;
    //       // $cr_angle_to = $request->cr_angle_to;
    //       // if (trim($cr_angle_from) != '' && trim($cr_angle_to)) {      
    //       //   $cr_angle_to = ($cr_angle_to=='10') ? '200' : $cr_angle_to;
    //       //   $where .= " AND crown_angle BETWEEN ($cr_angle_from) AND ($cr_angle_to)";
    //       // }

    //       // $cr_height_from = $request->cr_height_from;
    //       // $cr_height_to = $request->cr_height_to;
    //       // if (trim($cr_height_from) != '' && trim($cr_height_to)) {      
    //       //   $cr_height_to = ($cr_height_to=='10') ? '200' : $cr_height_to;
    //       //   $where .= " AND crown_ht BETWEEN ($cr_height_from) AND ($cr_height_to)";
    //       // }

    //       // $pav_angle_from = $request->pav_angle_from;
    //       // $pav_angle_to = $request->pav_angle_to;
    //       // if (trim($pav_angle_from) != '' && trim($pav_angle_to)) {      
    //       //   $pav_angle_to = ($pav_angle_to=='10') ? '200' : $pav_angle_to;
    //       //   $where .= " AND pavillion_angle BETWEEN ($pav_angle_from) AND ($pav_angle_to)";
    //       // }

    //       // $pav_height_from = $request->pav_height_from;
    //       // $pav_height_to = $request->pav_height_to;
    //       // if (trim($pav_height_from) != '' && trim($pav_height_to)) {      
    //       //   $pav_height_to = ($pav_height_to=='10') ? '200' : $pav_height_to;
    //       //   $where .= " AND pavillion_depth BETWEEN ($pav_height_from) AND ($pav_height_to)";
    //       // }

    //       // $girdle_per_from = $request->girdle_per_from;
    //       // $girdle_per_to = $request->girdle_per_to;
    //       // if (trim($girdle_per_from) != '' && trim($girdle_per_to)) {      
    //       //   $girdle_per_to = ($girdle_per_to=='10') ? '200' : $girdle_per_to;
    //       //   $where .= " AND girdle_perct BETWEEN ($girdle_per_from) AND ($girdle_per_to)";
    //       // }

    //       // $star_len_from = $request->star_len_from;
    //       // $star_len_to = $request->star_len_to;
    //       // if (trim($star_len_from) != '' && trim($star_len_to)) {      
    //       //   $star_len_to = ($star_len_to=='10') ? '200' : $star_len_to;
    //       //   $where .= " AND star_len BETWEEN ($star_len_from) AND ($star_len_to)";
    //       // }

    //       $per_pages = $request->per_pages;
    //       $limit = ($per_pages != '') ? $per_pages : $per_page ;
    //       $offset = ($page - 1) * $limit;
          
    //       $query = "select * from tbl_diamond where " .$where." limit 0,$limit"; 
    //       $records = DB::select($query);
    //       // print_ex($records);
          
    //       $query1 = "select COUNT(diamond_id) AS diamond_count from tbl_diamond where " .$where;
    //       $records_count = DB::select($query1);
    //       $data['records_count'] =$records_count['0']->diamond_count;
    //       // print_ex($data);
    //       echo json_encode(array(
    //         // 'pagination' => $pagination,
    //         'product_id'=>$product_id ?? '',
    //         'variants_id'=>$variants_id ?? '',
    //         'records'=>$records,
    //         'page_link'=>$pagination ?? '',
    //         'total_records'=>$data['records_count'],
    //         'theme_json'=>$theme_json ?? '',
    //         'isLogin' => 1,
    //         'page_name' => $page_name
    //       ));
    //     }
    //   }  
    // }

    public function find_range($range,$array_from)
    {
        $split = explode(';', $range);
        $split1 = @$split['0'];    
        $split2 = @$split['1'];
        $split1_key = array_search($split1, $array_from); 
        $split2_key = array_search($split2, $array_from);
        for ($i=$split1_key; $i <= $split2_key; $i++) { 
            $array[]=$array_from[$i];
        }
        return $array;
    }

    public function theme_changes(Request $request){

      $shop_name = $request->shop_name;
      $auth_token = $request->auth_token;
      $text_color = $request->text_color;
      $bg_color = $request->bg_color;
      $font_sizes = $request->font_size;
      // print_ex($font_size);
      $font_size = $font_sizes;
      $access_token = $request->access_token;

      $where = "name = '$shop_name'"; 
      // $where = "token = '$auth_token' AND name = '$shop_name'"; 
      $query = "select * from users where " .$where." limit 1";
      // print_ex($query);
      $user_data = DB::select($query); 
      if(!empty($user_data)){    
          $themeArray = [
            'text_color' => $text_color,
            'bg_color' => $bg_color,
            'font_size' => $font_size,
            'shop_name' => $shop_name,
            'auth_token' => $auth_token
          ];
          // print_ex(json_encode($themeArray));

          $update_query = "UPDATE users SET theme_json = '".json_encode($themeArray)."', token ='".$auth_token."', access_token ='".$access_token."' WHERE ".$where."";
          // print_ex($update_query);
          $rowsUpdated = DB::update($update_query);
        echo json_encode(array(
          // 'records'=>$user_data,
          'message'=> "Update Successfully."
        ));
      }else{
        echo json_encode(array(
          // 'records'=>[],
          'message'=> "Authentication Token Invaild."
        ));
      }
    }

    private function paginate($items, $perPage)
    {
        $currentPage = request()->get('page', 1); // Get the current page or default to 1

        // Slice the collection to get the items to display in current page
        $currentPageItems = array_slice($items, ($currentPage - 1) * $perPage, $perPage);

        // Create Laravel's LengthAwarePaginator instance
        return new \Illuminate\Pagination\LengthAwarePaginator(
            $currentPageItems, // Items to be paginated
            count($items),    // Total count of all items
            $perPage,         // Items per page
            $currentPage,     // Current page
            ['path' => request()->url()] // Additional paginator options
        );
    }

    function quick_detail(Request $request)
    {
      // $user_id = $this->session->userdata('user_id');
  
      // $showPrice = $this->user_model->showPrice($user_id);
      // $user_show_price = (!empty($showPrice)) ? $showPrice['0']->is_price : 0;
  
      $image_array =  $video_link = $certificate_array = [];
      $inventory_id = $request->stock_id;  
      $where = "diamond_id = '$inventory_id'"; 
        
      $query1 = "select * from tbl_diamond where " .$where;
      $records = DB::select($query1);
      // $records = $this->diamond_model->diamond_list($where);
  
      $image_array[] = $records['0']->diamond_image;
      $video_link[]=$records['0']->diamond_video;
      /*if($records['0']->report_filename!="")
      {
      if(checkLink($records['0']->report_filename)=='200'){
      $certificate_array[]=$records['0']->report_filename;
      }
      }*/
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      $isLogin = (!empty($user_id) && $user_show_price) ? 1 : 0;
  
      foreach ($records as $row) {
        $row->rapnet = '';
        if(!$isLogin) {        
          $row->rapnet_discount = $row->cost_carat = $row->total_price = '';
          $row->cash_price_discount = $row->cash_price = $row->cash_total_price = '';
        }
      }
      //print_ex($records);   
      $data= array(
        'records'=>$records,
        'image_array'=>$image_array,
        'certificate_array'=>$certificate_array ?? [],
        'video_link'=>$video_link,
        'isLogin' => $isLogin
      );
      echo json_encode($data);
    }

    function createProduct($jsonBody,$shop_name,$accessToken)
    {
      // print_ex($accessToken);
      if(empty($jsonBody)) {
        return [];
      }

        $shop_url = 'https://'.$shop_name.'/admin/api/2024-07/products.json'; // Replace with your Shopify store URL
        // $accessToken = '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'; // Replace with your access token
        
        // $dataSend = [
        //     'product' => [
        //         'title' => 'title demo',
        //         'body_html' => 'body_html demo',
        //     ]
        // ];

        $client = new Client([
            'base_uri' => $shop_url,
        ]);

        $headers = [
            'Content-Type' => 'application/json',
            'X-Shopify-Access-Token' => $accessToken,
        ];

        try {
            $response = $client->request('POST', 'https://'.$shop_name.'/admin/api/2024-07/products.json', [
                'headers' => $headers,
                'body' => $jsonBody,
            ]);

            $body = $response->getBody();
            $parsedBody = json_decode($body);
            // print_r($parsedBody);
            return $parsedBody;

            // return response()->json($parsedBody); // Return JSON response from Shopify
        } catch (\Exception $e) {
          return [];
            // return response()->json(['error' => $e->getMessage()], 500); // Handle any errors
        }
    }

    public function login(){
      session_start();
      $name = $_SESSION["name"] ?? "";
      $email = $_SESSION["email"] ?? "";
      $token = $_SESSION["token"] ?? "";
      //  print_r($email); die;
      if(empty($email)){
        return view('login');
      }else{  
        return Redirect(url('diamond'));
      }
    }

    function login_submit(Request $request){

      $email = $request->email;
      $password = hash('sha512',$request->password);
      $status = 0;
      
      $tbl_users_query = "select * from tbl_customer where email = '$email' and password = '$password' and status = 1";
      $user_data = DB::select($tbl_users_query); 
      // print_r($user_data); die;
      if(!empty($user_data)){
        session_start();
        $_SESSION["name"] = $user_data[0]->name;
        $_SESSION["email"] = $user_data[0]->email;
        $_SESSION["token"] = $user_data[0]->token;
        echo json_encode(array(
            'status' => 1,
            'message' => 'Login Successfully...'
        ));
      }else{
        echo json_encode(array(
          'status' => 0,
          'message' => 'Login Failed...'
      ));
      }
        
      
    }

    public function logout(){
      session_start();
      session_destroy();
      $_SESSION = array();
      $_SESSION["name"] = '';
      $_SESSION["email"] = '';
      $_SESSION["token"] = '';
      return Redirect(url('login'));
    }

    public function register(){
      return view('register');
    }

    function register_submit(Request $request){

      $name = $request->name;
      $email = $request->email;
      $phone = $request->phone;
      $password = hash('sha512',$request->password);
      $cpassword = $request->password;
      $website_url = $request->website_url;
      $token = hash('sha512',$request->website_url);
      // $token = hash('sha512',$request->email);
      $status = 0;
      $created_at = date('Y-m-d H:i:s');
      // echo $token; die;

      $tbl_users_query = "select * from tbl_customer where email = '$email'";
      $user_data = DB::select($tbl_users_query); 
      if(!empty($user_data)){
        echo json_encode(array(
          'status' => 0,
          'message' => 'Already Registered...'
        ));
      }else{
        try {
          DB::insert("
              INSERT INTO tbl_customer (
                  name,
                  email,
                  phone,
                  password,
                  cpassword,
                  website_url,
                  token,
                  status,
                  created_at
              ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)",
              [$name, $email, $phone, $password, $cpassword, $website_url, $token, $status, $created_at]
          );
  
          echo json_encode(array(
            'status' => 1,
            'message' => 'Register Successfully...'
          ));
          
        } catch (QueryException $e) { 
          echo json_encode(array(
            'status' => 0,
            'message' => 'Register Failed...'
          ));
          echo "Error inserting data: " . $e->getMessage();
        }
      }
      
    }


}
